{
Abstract: User Interface exports
Author:  Prof1983 <prof1983@yandex.ru>
Created: 28.04.2011
LastMod: 15.05.2011
Version: 0.3.0
}
unit AUIExp;

interface

uses
  AUI0, AUI03;

exports
  UI_Init,
  UI_Done,

  UI_ApplicationHandle,
  UI_HideOnClose,
  UI_InitMainTrayIcon,
  UI_InitMenus,
  UI_IsShowApp,
  UI_IsShowApp_Set,
  UI_OnMainFormCreate_Set,
  UI_ProcessMessages,
  UI_Run,
  UI_SetHideOnClose,
  UI_ShowHelp,
  UI_Shutdown,

  UI_Control_Free,
  UI_Control_GetEnabled,
  UI_Control_GetHint,
  UI_Control_GetName,
  UI_Control_GetVisible,
  UI_Control_SetAlign,
  UI_Control_SetEnabled,
  UI_Control_SetHint,
  UI_Control_SetName,
  UI_Control_SetPosition,
  UI_Control_SetSize,
  UI_Control_SetText,
  UI_Control_SetVisible,
  UI_DataSource_SetOnDataChange,
  UI_Dialog_About,
  UI_Dialog_Calendar,
  UI_Dialog_Error,
  UI_Dialog_DateFilter,
  UI_Dialog_InputBox,
  UI_Dialog_InputBox2,
  UI_Dialog_InputBoxA,
  UI_Dialog_Login,
  UI_Dialog_Message,
  UI_Dialog_OpenFile,
  UI_Dialog_OpenFileA,
  UI_Dialog_SaveFile,
  UI_Edit_CheckDate,
  UI_Edit_CheckFloat,
  UI_Edit_CheckInt,
  UI_Edit_New,
  UI_Grid_RestoreColProps,
  UI_Grid_SaveColProps,
  UI_Grid_SetColumnWidth,
  UI_Grid_SetColumnWidthA,
  UI_Grid_SetDataSource,
  UI_Label_New,
  UI_ListBox_Add,
  UI_ListBox_Clear,
  UI_MainToolBar,
  UI_MainTrayIcon,
  UI_MainWindow,
  UI_MainWindow_AddMenuItem,
  UI_MainWindow_AddMenuItem2,
  UI_MainWindow_Set,
  UI_Menu_GetItems,
  UI_MenuItem_Add,
  UI_MenuItem_Add2,
  UI_MenuItem_FindByName,
  UI_PageControl_AddPage,
  UI_PageControl_New,
  UI_SpinButton_New,
  UI_SpinEdit_New,
  UI_SpinEdit_NewA,
  UI_Splitter_New,
  UI_ToolBar_AddButton,
  UI_TreeView_New,
  UI_WaitWin_New,
  UI_WaitWin_StepBy,
  UI_Window_Free,
  UI_Window_GetMenu,
  UI_Window_LoadConfig,
  UI_Window_New,
  UI_Window_SaveConfig;

const
  UIProcs: AUIProcsType = (
    InitMainTrayIcon: AUI03.UI_InitMainTrayIcon;
    InitMenus: AUI03.UI_InitMenus;
    IsShowApp: AUI03.UI_IsShowApp;
    IsShowApp_Set: AUI03.UI_IsShowApp_Set;
    OnMainFormCreate_Set: AUI03.UI_OnMainFormCreate_Set;
    ProcessMessages: AUI03.UI_ProcessMessages;
    ShowHelp: AUI03.UI_ShowHelp;
    Shutdown: AUI03.UI_Shutdown;

    Box_New: AUI03.UI_Box_New;
    Button_New: AUI03.UI_Button_New;

    Calendar_GetDate: AUI03.UI_Calendar_GetDate;
    Calendar_New: AUI03.UI_Calendar_New;
    Calendar_SetMonth: AUI03.UI_Calendar_SetMonth;

    Control_Free: AUI03.UI_Control_Free;
    Control_FreeAndNil: AUI03.UI_Control_FreeAndNil;
    Control_GetEnabled: AUI03.UI_Control_GetEnabled;
    Control_GetHeight: AUI03.UI_Control_GetHeight;
    Control_GetHint: AUI03.UI_Control_GetHint;
    Control_GetName: AUI03.UI_Control_GetName;
    Control_GetText: AUI03.UI_Control_GetText;
    Control_GetVisible: AUI03.UI_Control_GetVisible;
    Control_GetWidth: AUI03.UI_Control_GetWidth;
    Control_SetAlign: AUI03.UI_Control_SetAlign;
    Control_SetClientSize: AUI03.UI_Control_SetClientSize;
    Control_SetColor: AUI03.UI_Control_SetColor;
    Control_SetEnabled: AUI03.UI_Control_SetEnabled;
    Control_SetFocus: AUI03.UI_Control_SetFocus;
    Control_SetFont1: AUI03.UI_Control_SetFont1;
    Control_SetFont2: AUI03.UI_Control_SetFont2;
    Control_SetHint: AUI03.UI_Control_SetHint;
    Control_SetName: AUI03.UI_Control_SetName;
    Control_SetOnChange: AUI03.UI_Control_SetOnChange;
    Control_SetOnClick: AUI03.UI_Control_SetOnClick;
    Control_SetPosition: AUI03.UI_Control_SetPosition;
    Control_SetSize: AUI03.UI_Control_SetSize;
    Control_SetText: AUI03.UI_Control_SetText;
    Control_SetVisible: AUI03.UI_Control_SetVisible;
    Control_SetWidth: AUI03.UI_Control_SetWidth;

    DataSource_New: AUI03.UI_DataSource_New;
    DataSource_SetOnDataChange: AUI03.UI_DataSource_SetOnDataChange;

    Dialog_About: AUI03.UI_Dialog_About;
    Dialog_About_New: AUI03.UI_Dialog_About_New;
    Dialog_AddButton: AUI03.UI_Dialog_AddButton;
    Dialog_Calendar: AUI03.UI_Dialog_Calendar;
    Dialog_Color: AUI03.UI_Dialog_Color;
    Dialog_DateFilter: AUI03.UI_Dialog_DateFilter;
    Dialog_Error: AUI03.UI_Dialog_Error;
    Dialog_Font: AUI03.UI_Dialog_Font;
    Dialog_GetWindow: AUI03.UI_Dialog_GetWindow;
    Dialog_InputBox: AUI03.UI_Dialog_InputBox;
    Dialog_InputBox2: AUI03.UI_Dialog_InputBox2;
    Dialog_InputBoxA: AUI03.UI_Dialog_InputBoxA;
    Dialog_Login: AUI03.UI_Dialog_Login;
    Dialog_Message: AUI03.UI_Dialog_Message;
    Dialog_New: AUI03.UI_Dialog_New;
    Dialog_OpenFile: AUI03.UI_Dialog_OpenFile;
    Dialog_OpenFileA: AUI03.UI_Dialog_OpenFileA;
    Dialog_SaveFile: AUI03.UI_Dialog_SaveFile;
    Dialog_SaveFileA: AUI03.UI_Dialog_SaveFileA;

    Edit_CheckDate: AUI03.UI_Edit_CheckDate;
    Edit_CheckFloat: AUI03.UI_Edit_CheckFloat;
    Edit_CheckInt: AUI03.UI_Edit_CheckInt;
    Edit_New: AUI03.UI_Edit_New;
    Edit_NewA: AUI03.UI_Edit_NewA;

    Grid_AddColumn: AUI03.UI_Grid_AddColumn;
    Grid_New: AUI03.UI_Grid_New;
    Grid_RestoreColProps: AUI03.UI_Grid_RestoreColProps;
    Grid_SaveColProps: AUI03.UI_Grid_SaveColProps;
    Grid_SetColumnWidth: AUI03.UI_Grid_SetColumnWidth;
    Grid_SetColumnWidthA: AUI03.UI_Grid_SetColumnWidthA;
    Grid_SetDataSource: AUI03.UI_Grid_SetDataSource;

    Image_New: AUI03.UI_Image_New;
    Image_LoadFromFile: AUI03.UI_Image_LoadFromFile;

    Label_New: AUI03.UI_Label_New;

    ListBox_Add: AUI03.UI_ListBox_Add;
    ListBox_Clear: AUI03.UI_ListBox_Clear;
    ListBox_New: AUI03.UI_ListBox_New;

    MainToolBar: AUI03.UI_MainToolBar;
    //MainToolBar_Set: AUI03.UI_MainToolBar_Set;

    MainTrayIcon: AUI03.UI_MainTrayIcon;

    MainWindow: AUI03.UI_MainWindow;
    MainWindow_AddMenuItem: AUI03.UI_MainWindow_AddMenuItem;
    MainWindow_AddMenuItem2: AUI03.UI_MainWindow_AddMenuItem2;
    MainWindow_GetLeftContainer: AUI03.UI_MainWindow_GetLeftContainer;
    MainWindow_GetMainContainer: AUI03.UI_MainWindow_GetMainContainer;
    MainWindow_GetRightContainer: AUI03.UI_MainWindow_GetRightContainer;
    MainWindow_Set: AUI03.UI_MainWindow_Set;
    MainWindow_SetA: AUI03.UI_MainWindow_SetA;

    Menu_GetItems: AUI03.UI_Menu_GetItems;
    Menu_New: AUI03.UI_Menu_New;

    MenuItem_Add: AUI03.UI_MenuItem_Add;
    MenuItem_Add2: AUI03.UI_MenuItem_Add2;
    MenuItem_FindByName: AUI03.UI_MenuItem_FindByName;

    PageControl_AddPage: AUI03.UI_PageControl_AddPage;
    PageControl_New: AUI03.UI_PageControl_New;

    ProgressBar_New: AUI03.UI_ProgressBar_New;
    ProgressBar_StepIt: AUI03.UI_ProgressBar_StepIt;

    PropertyBox_Add: AUI03.UI_PropertyBox_Add;
    PropertyBox_AddA: AUI03.UI_PropertyBox_AddA;
    PropertyBox_Item_GetValue: AUI03.UI_PropertyBox_Item_GetValue;
    PropertyBox_Item_SetValue: AUI03.UI_PropertyBox_Item_SetValue;
    PropertyBox_New: AUI03.UI_PropertyBox_New;

    ReportWin_New: AUI03.UI_ReportWin_New;
    ReportWin_NewA: AUI03.UI_ReportWin_NewA;

    Splitter_New: AUI03.UI_Splitter_New;

    TextView_AddLine: AUI03.UI_TextView_AddLine;
    TextView_New: AUI03.UI_TextView_New;
    TextView_SetFont: AUI03.UI_TextView_SetFont;
    TextView_SetReadOnly: AUI03.UI_TextView_SetReadOnly;
    TextView_SetScrollBars: AUI03.UI_TextView_SetScrollBars;
    TextView_SetWordWrap: AUI03.UI_TextView_SetWordWrap;

    ToolBar_AddButton: AUI03.UI_ToolBar_AddButton;
    ToolBar_New: AUI03.UI_ToolBar_New;

    TrayIcon_GetMenuItems: AUI03.UI_TrayIcon_GetMenuItems;

    TreeView_AddItem: AUI03.UI_TreeView_AddItem;
    TreeView_New: AUI03.UI_TreeView_New;

    WaitWin_New: AUI03.UI_WaitWin_New;
    WaitWin_StepBy: AUI03.UI_WaitWin_StepBy;

    Window_Free: AUI03.UI_Window_Free;
    Window_GetMenu: AUI03.UI_Window_GetMenu;
    Window_LoadConfig: AUI03.UI_Window_LoadConfig;
    Window_LoadConfig2: AUI03.UI_Window_LoadConfig2;
    Window_New: AUI03.UI_Window_New;
    Window_SaveConfig: AUI03.UI_Window_SaveConfig;
    Window_SaveConfig2: AUI03.UI_Window_SaveConfig2;
    Window_SetBorderStyle: AUI03.UI_Window_SetBorderStyle;
    Window_SetFormStyle: AUI03.UI_Window_SetFormStyle;
    Window_SetPosition: AUI03.UI_Window_SetPosition;
    Window_ShowModal: AUI03.UI_Window_ShowModal;

    Reserved129: 0;
    Reserved130: 0;
    Reserved131: 0;
    Reserved132: 0;
    Reserved133: 0;
    Reserved134: 0;
    Reserved135: 0;
    Reserved136: 0;
    Reserved137: 0;
    Reserved138: 0;
    Reserved139: 0;
    Reserved140: 0;
    Reserved141: 0;
    Reserved142: 0;
    Reserved143: 0;

    Reserved144: 0;
    Reserved145: 0;
    Reserved146: 0;
    Reserved147: 0;
    Reserved148: 0;
    Reserved149: 0;
    Reserved150: 0;
    Reserved151: 0;
    Reserved152: 0;
    Reserved153: 0;
    Reserved154: 0;
    Reserved155: 0;
    Reserved156: 0;
    Reserved157: 0;
    Reserved158: 0;
    Reserved159: 0;

    Reserved160: 0;
    Reserved161: 0;
    Reserved162: 0;
    Reserved163: 0;
    Reserved164: 0;
    Reserved165: 0;
    Reserved166: 0;
    Reserved167: 0;
    Reserved168: 0;
    Reserved169: 0;
    Reserved170: 0;
    Reserved171: 0;
    Reserved172: 0;
    Reserved173: 0;
    Reserved174: 0;
    Reserved175: 0;

    Reserved176: 0;
    Reserved177: 0;
    Reserved178: 0;
    Reserved179: 0;
    Reserved180: 0;
    Reserved181: 0;
    Reserved182: 0;
    Reserved183: 0;
    Reserved184: 0;
    Reserved185: 0;
    Reserved186: 0;
    Reserved187: 0;
    Reserved188: 0;
    Reserved189: 0;
    Reserved190: 0;
    Reserved191: 0;

    Reserved192: 0;
    Reserved193: 0;
    Reserved194: 0;
    Reserved195: 0;
    Reserved196: 0;
    Reserved197: 0;
    Reserved198: 0;
    Reserved199: 0;
    Reserved200: 0;
    Reserved201: 0;
    Reserved202: 0;
    Reserved203: 0;
    Reserved204: 0;
    Reserved205: 0;
    Reserved206: 0;
    Reserved207: 0;

    Reserved208: 0;
    Reserved209: 0;
    Reserved210: 0;
    Reserved211: 0;
    Reserved212: 0;
    Reserved213: 0;
    Reserved214: 0;
    Reserved215: 0;
    Reserved216: 0;
    Reserved217: 0;
    Reserved218: 0;
    Reserved219: 0;
    Reserved220: 0;
    Reserved221: 0;
    Reserved222: 0;
    Reserved223: 0;

    Reserved224: 0;
    Reserved225: 0;
    Reserved226: 0;
    Reserved227: 0;
    Reserved228: 0;
    Reserved229: 0;
    Reserved230: 0;
    Reserved231: 0;
    Reserved232: 0;
    Reserved233: 0;
    Reserved234: 0;
    Reserved235: 0;
    Reserved236: 0;
    Reserved237: 0;
    Reserved238: 0;
    Reserved239: 0;

    Reserved240: 0;
    Reserved241: 0;
    Reserved242: 0;
    Reserved243: 0;
    Reserved244: 0;
    Reserved245: 0;
    Reserved246: 0;
    Reserved247: 0;
    Reserved248: 0;
    Reserved249: 0;
    Reserved250: 0;
    Reserved251: 0;
    Reserved252: 0;
    Reserved253: 0;
    Reserved254: 0;
    Reserved255: 0;
    );

implementation

end.
